/*
 * Copyright 2008 Google Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package org.opencms.gwt.rebind.rpc;

import com.google.gwt.core.ext.typeinfo.JClassType;
import com.google.gwt.user.rebind.rpc.ProxyCreator;
import com.google.gwt.user.rebind.rpc.ServiceInterfaceProxyGenerator;

/**
 * Creates proxies supporting optionally synchronized RPC methods using the 
 * {@link com.google.gwt.user.client.rpc.SynchronizedRpcRequest} annotation.<p>
 */
public class CmsRpcServiceGenerator extends ServiceInterfaceProxyGenerator {

    /**
     * @see com.google.gwt.user.rebind.rpc.ServiceInterfaceProxyGenerator#createProxyCreator(com.google.gwt.core.ext.typeinfo.JClassType)
     */
    @Override
    protected ProxyCreator createProxyCreator(JClassType remoteService) {

        return new CmsRpcProxyCreator(remoteService);
    }
}
